Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_genMealy_decod_out.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_genMealy_decod_out.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_genMealy_decod_out.cpp	(revision 111)
@@ -25,86 +25,5 @@
     log_function(Decod_queue,FUNCTION,_name.c_str());
 
-    Tcontrol_t val [_param->_nb_inst_decod];
-    for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
-      {
-	val                    [i] = 0;
-	internal_DECOD_OUT_VAL [i] = 0;
-	internal_DECOD_OUT_ACK [i] = 0;
-      }
-
-    if (not reg_QUEUE->empty())
-      for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
-        {
-          uint32_t index = reg_LAST_SLOT + i;
-
-          // Stop
-          if (index >= _param->_nb_inst_decod)
-            break;
-
-          if (reg_QUEUE->front()->_val [index])
-            {
-              log_printf(TRACE,Decod_queue,FUNCTION,_("  * Queue is not empty, slot [%d] is valid."),i);
-              
-              Tcontext_t context         = reg_QUEUE->front()->_context_id    [index];
-              Tdepth_t   depth           = reg_QUEUE->front()->_depth         [index];
-              Tdepth_t   depth_min       = (_param->_have_port_depth)?PORT_READ(in_DEPTH_MIN [context]):0;
-              Tdepth_t   depth_max       = (_param->_have_port_depth)?PORT_READ(in_DEPTH_MAX [context]):0;
-              Tcontrol_t depth_full      = PORT_READ(in_DEPTH_FULL[context]);
-
-              // is a valid instruction ?
-              // If DEPTH_CURRENT :
-              // equal at     DEPTH_MIN            -> not speculative
-              // not include ]DEPTH_MIN:DEPTH_MAX] -> previous branch miss
-              //     include ]DEPTH_MIN:DEPTH_MAX] -> speculative
-              
-              // All case
-              // ....... min ...X... max ....... OK
-              // ....... min ....... max ...X... KO
-              // ...X... min ....... max ....... KO
-              // ....... max ....... min ...X... OK
-              // ...X... max ....... min ....... OK
-              // ....... max ...X... min ....... KO
-              
-              Tcontrol_t   is_valid      = ((depth == depth_min) or
-                                            depth_full or
-                                            ((depth_min <= depth_max)?
-                                             ((depth >= depth_min) and (depth <=depth_max)):
-                                             ((depth >= depth_min) or  (depth <=depth_max))));
-              //Tcontrol_t is_valid        = ((depth == depth_min) or 
-              //                              ((depth_min < depth_max)?
-              //                               (depth<=depth_max):
-              //                               ((depth > depth_min) or (depth <= depth_max))));
-              //Tcontrol_t is_valid        = depth <= depth_max;
-
-              log_printf(TRACE,Decod_queue,FUNCTION,"    * is_valid : %d",is_valid);
-              log_printf(TRACE,Decod_queue,FUNCTION,"      * context      : %d",context);
-              log_printf(TRACE,Decod_queue,FUNCTION,"      * depth        : %d",depth);
-              log_printf(TRACE,Decod_queue,FUNCTION,"      * depth_min    : %d",depth_min);
-              log_printf(TRACE,Decod_queue,FUNCTION,"      * depth_max    : %d",depth_max);
-              log_printf(TRACE,Decod_queue,FUNCTION,"      * depth_full   : %d",depth_full);
-#ifdef DEBUG
-              log_printf(TRACE,Decod_queue,FUNCTION,"      * address      : 0x%x (0x%x)",reg_QUEUE->front()->_address     [index],reg_QUEUE->front()->_address     [index]<<2);
-#endif
-              log_printf(TRACE,Decod_queue,FUNCTION,"      * address_next : 0x%x (0x%x)",reg_QUEUE->front()->_address_next[index],reg_QUEUE->front()->_address_next[index]<<2);
-              internal_DECOD_OUT_VAL [index] = 1; // in all case, val is set (entry is not empty, and instruction is valid)
-              if (is_valid)
-                {
-                  val                    [i]     = 1;
-                  internal_DECOD_OUT_ACK [index] = PORT_READ(in_DECOD_OUT_ACK [i]);
-                }
-              else
-                {
-                  // Consume the instruction (to erase)
-                  internal_DECOD_OUT_ACK [index] = 1;
-                }
-            }
-      }
-
-    for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
-      {
-        log_printf(TRACE,Decod_queue,FUNCTION,"  * DECOD_OUT_VAL : %d",val [i]);
-        
-        PORT_WRITE(out_DECOD_OUT_VAL [i],val [i]);
-      }
+    (this->*function_genMealy_decod_out) ();
 
     log_end(Decod_queue,FUNCTION);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_genMoore.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_genMoore.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_genMoore.cpp	(revision 111)
@@ -25,62 +25,5 @@
     log_function(Decod_queue,FUNCTION,_name.c_str());
 
-    //--------------------------------------------------------------------
-    //-----[ DECOD_IN ]---------------------------------------------------
-    //--------------------------------------------------------------------
-    {
-      Tcontrol_t ack = reg_QUEUE->size() < _param->_size_queue;
-
-      for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
-	{
-	  internal_DECOD_IN_ACK [i] = ack;
-	  PORT_WRITE(out_DECOD_IN_ACK [i],ack);
-	}
-    }
-
-    //--------------------------------------------------------------------
-    //-----[ DECOD_OUT ]--------------------------------------------------
-    //--------------------------------------------------------------------
-    if (not reg_QUEUE->empty())
-      for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
-	{
-          uint32_t index = reg_LAST_SLOT + i;
-
-          // Stop
-          if (index >= _param->_nb_inst_decod)
-            break;
-
-	  if (_param->_have_port_context_id)
-	  PORT_WRITE(out_DECOD_OUT_CONTEXT_ID    [i],reg_QUEUE->front()->_context_id    [index]);
-	  if (_param->_have_port_depth)
-	  PORT_WRITE(out_DECOD_OUT_DEPTH         [i],reg_QUEUE->front()->_depth         [index]);
-	  PORT_WRITE(out_DECOD_OUT_TYPE          [i],reg_QUEUE->front()->_type          [index]);
-	  PORT_WRITE(out_DECOD_OUT_OPERATION     [i],reg_QUEUE->front()->_operation     [index]);
-	  PORT_WRITE(out_DECOD_OUT_NO_EXECUTE    [i],reg_QUEUE->front()->_no_execute    [index]);
-	  PORT_WRITE(out_DECOD_OUT_IS_DELAY_SLOT [i],reg_QUEUE->front()->_is_delay_slot [index]);
-#ifdef DEBUG
-	  PORT_WRITE(out_DECOD_OUT_ADDRESS       [i],reg_QUEUE->front()->_address       [index]);
-#endif
-	  PORT_WRITE(out_DECOD_OUT_ADDRESS_NEXT  [i],reg_QUEUE->front()->_address_next  [index]);
-	  PORT_WRITE(out_DECOD_OUT_HAS_IMMEDIAT  [i],reg_QUEUE->front()->_has_immediat  [index]);
-	  PORT_WRITE(out_DECOD_OUT_IMMEDIAT      [i],reg_QUEUE->front()->_immediat      [index]);
-	  PORT_WRITE(out_DECOD_OUT_READ_RA       [i],reg_QUEUE->front()->_read_ra       [index]);
-	  PORT_WRITE(out_DECOD_OUT_NUM_REG_RA    [i],reg_QUEUE->front()->_num_reg_ra    [index]);
-	  PORT_WRITE(out_DECOD_OUT_READ_RB       [i],reg_QUEUE->front()->_read_rb       [index]);
-	  PORT_WRITE(out_DECOD_OUT_NUM_REG_RB    [i],reg_QUEUE->front()->_num_reg_rb    [index]);
-	  PORT_WRITE(out_DECOD_OUT_READ_RC       [i],reg_QUEUE->front()->_read_rc       [index]);
-	  PORT_WRITE(out_DECOD_OUT_NUM_REG_RC    [i],reg_QUEUE->front()->_num_reg_rc    [index]);
-	  PORT_WRITE(out_DECOD_OUT_WRITE_RD      [i],reg_QUEUE->front()->_write_rd      [index]);
-	  PORT_WRITE(out_DECOD_OUT_NUM_REG_RD    [i],reg_QUEUE->front()->_num_reg_rd    [index]);
-	  PORT_WRITE(out_DECOD_OUT_WRITE_RE      [i],reg_QUEUE->front()->_write_re      [index]);
-	  PORT_WRITE(out_DECOD_OUT_NUM_REG_RE    [i],reg_QUEUE->front()->_num_reg_re    [index]);
-	  PORT_WRITE(out_DECOD_OUT_EXCEPTION_USE [i],reg_QUEUE->front()->_exception_use [index]);
-	  PORT_WRITE(out_DECOD_OUT_EXCEPTION     [i],reg_QUEUE->front()->_exception     [index]);
-	}
-
-    //--------------------------------------------------------------------
-    //-----[ NB_INST ]----------------------------------------------------
-    //--------------------------------------------------------------------
-    for (uint32_t i=0; i<_param->_nb_context; i++)
-      PORT_WRITE(out_NB_INST_ALL [i], reg_NB_INST [i]);
+    (this->*function_genMoore) ();
 
     log_end(Decod_queue,FUNCTION);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_transition.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_transition.cpp	(revision 111)
@@ -25,184 +25,5 @@
     log_function(Decod_queue,FUNCTION,_name.c_str());
 
-    if (PORT_READ(in_NRESET) == 0)
-      {
-	reg_QUEUE->clear();
-
-	for (uint32_t i=0; i<_param->_nb_context; i++)
-	  reg_NB_INST [i]=0;
-
-        reg_LAST_SLOT = 0;
-      }
-    else
-      {
-	//--------------------------------------------------------------------
-	//-----[ DECOD_IN ]---------------------------------------------------
-	//--------------------------------------------------------------------	
-        decod_queue_entry_t * entry = NULL;
-        for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
-	  {
-	    if (PORT_READ(in_DECOD_IN_VAL [i]) and internal_DECOD_IN_ACK[i])
-	      {
-		log_printf(TRACE,Decod_queue,FUNCTION,_("  * DECOD_IN  [%d]"),i);
-
-		if (entry == NULL)
-                 {
-                   // Once creation and insert in queue
-                   entry = new decod_queue_entry_t (_param->_nb_inst_decod);
-                   reg_QUEUE->push_back(entry);
-
-#ifdef STATISTICS
-                   if (usage_is_set(_usage,USE_STATISTICS))
-                     (*_stat_sum_transaction_decod_in) ++;
-#endif
-                 }
-
-#ifdef STATISTICS
-                if (usage_is_set(_usage,USE_STATISTICS))
-                  (*_stat_sum_inst_enable) ++;
-#endif
-
-		Tcontext_t context = (_param->_have_port_context_id)?PORT_READ(in_DECOD_IN_CONTEXT_ID [i]):0;
-
-		log_printf(TRACE,Decod_queue,FUNCTION,_("    * context : %d"),context);
-
-		entry->_val           [i] = 1;
-		entry->_context_id    [i] = context;
-		entry->_depth         [i] = (_param->_have_port_depth)?PORT_READ(in_DECOD_IN_DEPTH [i]):0;
-		entry->_type          [i] = PORT_READ(in_DECOD_IN_TYPE          [i]);
-		entry->_operation     [i] = PORT_READ(in_DECOD_IN_OPERATION     [i]);
-		entry->_no_execute    [i] = PORT_READ(in_DECOD_IN_NO_EXECUTE    [i]);
-		entry->_is_delay_slot [i] = PORT_READ(in_DECOD_IN_IS_DELAY_SLOT [i]);
-#ifdef DEBUG
-		entry->_address       [i] = PORT_READ(in_DECOD_IN_ADDRESS       [i]);
-#endif
-		entry->_address_next  [i] = PORT_READ(in_DECOD_IN_ADDRESS_NEXT  [i]);
-		entry->_has_immediat  [i] = PORT_READ(in_DECOD_IN_HAS_IMMEDIAT  [i]);
-		entry->_immediat      [i] = PORT_READ(in_DECOD_IN_IMMEDIAT      [i]);
-		entry->_read_ra       [i] = PORT_READ(in_DECOD_IN_READ_RA       [i]);
-		entry->_num_reg_ra    [i] = PORT_READ(in_DECOD_IN_NUM_REG_RA    [i]);
-		entry->_read_rb       [i] = PORT_READ(in_DECOD_IN_READ_RB       [i]);
-		entry->_num_reg_rb    [i] = PORT_READ(in_DECOD_IN_NUM_REG_RB    [i]);
-		entry->_read_rc       [i] = PORT_READ(in_DECOD_IN_READ_RC       [i]);
-		entry->_num_reg_rc    [i] = PORT_READ(in_DECOD_IN_NUM_REG_RC    [i]);
-		entry->_write_rd      [i] = PORT_READ(in_DECOD_IN_WRITE_RD      [i]);
-		entry->_num_reg_rd    [i] = PORT_READ(in_DECOD_IN_NUM_REG_RD    [i]);
-		entry->_write_re      [i] = PORT_READ(in_DECOD_IN_WRITE_RE      [i]);
-		entry->_num_reg_re    [i] = PORT_READ(in_DECOD_IN_NUM_REG_RE    [i]);
-		entry->_exception_use [i] = PORT_READ(in_DECOD_IN_EXCEPTION_USE [i]);
-		entry->_exception     [i] = PORT_READ(in_DECOD_IN_EXCEPTION     [i]);
-
-		reg_NB_INST [context] ++;
-
-		log_printf(TRACE,Decod_queue,FUNCTION,_("    * nb_inst : %d"),reg_NB_INST [context]);
-		log_printf(TRACE,Decod_queue,FUNCTION,_("    * PUSH queue"));
-	      }
-	  }
-
-	//--------------------------------------------------------------------
-	//-----[ DECOD_OUT ]--------------------------------------------------
-	//--------------------------------------------------------------------
-	if (not reg_QUEUE->empty())
-	  {
- 	    bool find = false;
-	    
-	    for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
-	      {
-		// Test transaction : if ok then invalid slot
-                // In order by rename logic
-		if (internal_DECOD_OUT_VAL [i] and internal_DECOD_OUT_ACK[i])
-		  {
-		    log_printf(TRACE,Decod_queue,FUNCTION,_("  * DECOD_OUT [%d]"),i);
-		
-#ifdef DEBUG_TEST
-                    if (reg_LAST_SLOT != i)
-                      throw ERRORMORPHEO(FUNCTION,toString(_("reg_LAST_SLOT (%d) is different at decod_out port (%d)."),reg_LAST_SLOT,i));
-#endif
-                    reg_LAST_SLOT ++;
-
-		    reg_QUEUE->front()->_val [i] = 0;
-
-		    Tcontext_t context = reg_QUEUE->front()->_context_id [i];
-		    log_printf(TRACE,Decod_queue,FUNCTION,_("    * context : %d"),context);
-		    
-		    reg_NB_INST [context] --;
-		    log_printf(TRACE,Decod_queue,FUNCTION,_("    * nb_inst : %d"),reg_NB_INST [context]);
-		  }
-		// Test if slot is (again) valid, if yes, then have less one instruction in the entry
- 		find |= reg_QUEUE->front()->_val [i];
-	      }
-	    
-	    // test if can free the entry : test if have consume all entry
-            if (not find) // no valid instruction in current slot
-	      {
-		log_printf(TRACE,Decod_queue,FUNCTION,_("    * POP  queue"));
-
-		// can pop the slot
-		delete reg_QUEUE->front();
-		reg_QUEUE->pop_front();
-
-                reg_LAST_SLOT = 0;
-	      }
-	  }
-      }
-
-#if defined(DEBUG) and defined(DEBUG_Decod_queue) and (DEBUG >= DEBUG_TRACE)
-    log_printf(TRACE,Decod_queue,FUNCTION,"  * Dump decod_queue");
-    log_printf(TRACE,Decod_queue,FUNCTION,"    * reg_LAST_SLOT : %d",reg_LAST_SLOT);
-    uint32_t x=0;
-    for (std::list<decod_queue_entry_t*>::iterator it=reg_QUEUE->begin();
-	 it!=reg_QUEUE->end();
-	 it++)
-      {
-	for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
-	  {
-	    if ((*it)->_val [i])
-	      log_printf(TRACE,Decod_queue,FUNCTION,"    * [%.4d][%.4d] %.1d, %.3d %.2d, %.2d %.3d %.1d %.1d, 0x%.8x (0x%.8x), %.1d 0x%.8x, %.1d %.2d, %.1d %.2d, %.1d %.2d, %.1d %.2d, %.1d %.2d, %.1d %.2d"
-			 ,x
-                         ,i
-			 ,(*it)->_val           [i]
-			 ,(*it)->_context_id    [i]
-			 ,(*it)->_depth         [i]
-			 ,(*it)->_type          [i]
-			 ,(*it)->_operation     [i]
-			 ,(*it)->_no_execute    [i]
-			 ,(*it)->_is_delay_slot [i]
-			 ,(*it)->_address       [i]
-			 ,(*it)->_address       [i]<<2
-			 ,(*it)->_has_immediat  [i]
-			 ,(*it)->_immediat      [i]
-			 ,(*it)->_read_ra       [i]
-			 ,(*it)->_num_reg_ra    [i]
-			 ,(*it)->_read_rb       [i]
-			 ,(*it)->_num_reg_rb    [i]
-			 ,(*it)->_read_rc       [i]
-			 ,(*it)->_num_reg_rc    [i]
-			 ,(*it)->_write_rd      [i]
-			 ,(*it)->_num_reg_rd    [i]
-			 ,(*it)->_write_re      [i]
-			 ,(*it)->_num_reg_re    [i]
-			 ,(*it)->_exception_use [i]
-			 ,(*it)->_exception     [i]
-			 );
-	    else
-	      log_printf(TRACE,Decod_queue,FUNCTION,"    * [%.4d][%.4d] %d"
-			 ,x
-                         ,i
-			 ,(*it)->_val           [i]
-			 );
-
-	  }
-	x++;
-      }
-#endif
-    
-#ifdef STATISTICS
-    if (usage_is_set(_usage,USE_STATISTICS))
-      {	
-        *(_stat_use_queue) += reg_QUEUE->size();
-        for (uint32_t i=0; i<_param->_nb_context; i++)
-          *(_stat_nb_inst [i]) += reg_NB_INST [i];
-      }
-#endif
+    (this->*function_transition) ();
 
 #if defined(STATISTICS) or defined(VHDL_TESTBENCH)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Parameters.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Parameters.cpp	(revision 111)
@@ -20,10 +20,11 @@
 #undef  FUNCTION
 #define FUNCTION "Decod_queue::Parameters"
-  Parameters::Parameters (uint32_t   nb_context          ,
-			  uint32_t   nb_inst_decod       ,
-			  uint32_t   size_queue          ,
-			  uint32_t   size_general_data   ,
-			  uint32_t * nb_branch_speculated,
-                          bool       is_toplevel         )
+  Parameters::Parameters (uint32_t              nb_context          ,
+                          uint32_t              nb_inst_decod       ,
+                          uint32_t              size_queue          ,
+                          Tdecod_queue_scheme_t queue_scheme        ,
+                          uint32_t              size_general_data   ,
+                          uint32_t            * nb_branch_speculated,
+                          bool                  is_toplevel)
   {
     log_begin(Decod_queue,FUNCTION);
@@ -32,8 +33,11 @@
     _nb_inst_decod           = nb_inst_decod           ;
     _size_queue              = size_queue/nb_inst_decod;
-//  _size_general_data       = size_general_data   ;
-    _nb_branch_speculated    = nb_branch_speculated;
-    _nb_instruction_in_queue = size_queue;
-    
+    _queue_scheme            = queue_scheme            ;
+//  _size_general_data       = size_general_data       ;
+    _nb_branch_speculated    = nb_branch_speculated    ;
+    _nb_instruction_in_queue = size_queue              ;
+
+    _nb_bank                 = nb_inst_decod           ;
+
     test();
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Parameters_msg_error.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Parameters_msg_error.cpp	(revision 111)
@@ -30,4 +30,18 @@
       test.error("Size of decod queue must be a multiple of nb_instruction.\n");
 
+    switch (_queue_scheme)
+      {
+      case DECOD_QUEUE_SCHEME_ONE_FIFO :
+      case DECOD_QUEUE_SCHEME_MULTI_FIFO :
+        {
+          break;
+        }
+      default :
+	{
+ 	  test.error(toString(_("Decod queue scheme '%s' is not supported. Please wait a next revision.\n"),toString(_queue_scheme).c_str()));
+	  break;
+	}
+      }
+
     log_end(Decod_queue,FUNCTION);
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Parameters_print.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Parameters_print.cpp	(revision 111)
@@ -30,4 +30,5 @@
     xml.singleton_begin("nb_inst_decod       "); xml.attribut("value",toString(_nb_inst_decod    )); xml.singleton_end();
     xml.singleton_begin("size_queue          "); xml.attribut("value",toString(_size_queue       )); xml.singleton_end();
+    xml.singleton_begin("queue_scheme        "); xml.attribut("value",toString(_queue_scheme     )); xml.singleton_end();
     xml.singleton_begin("size_general_data   "); xml.attribut("value",toString(_size_general_data)); xml.singleton_end();
     for (uint32_t i=0;i<_nb_context; i++)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/SelfTest/config_min.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/SelfTest/config_min.cfg	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/SelfTest/config_min.cfg	(revision 111)
@@ -4,4 +4,5 @@
 1	1	+1	# nb_inst_decod                
 1	1	+1	# size_queue                   
+0	1	+1	# queue_scheme
 32	32	+1	# size_general_data            
 1	1	+1	# nb_branch_speculated         [0][nb_context]
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/SelfTest/config_mono_context.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/SelfTest/config_mono_context.cfg	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/SelfTest/config_mono_context.cfg	(revision 111)
@@ -4,4 +4,5 @@
 1	4	*4	# nb_inst_decod                
 4	16	*4	# size_queue                   
+0	1	+1	# queue_scheme
 32	32	+1	# size_general_data            
 1	1	*4	# nb_branch_speculated         [0][nb_context]
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/SelfTest/config_multi_context.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/SelfTest/config_multi_context.cfg	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/SelfTest/config_multi_context.cfg	(revision 111)
@@ -7,4 +7,5 @@
 1	8 	*4	# nb_inst_decod                 
 16	16	*4	# size_queue                    
+0	1	+1	# queue_scheme
 32	32	+1	# size_general_data             
 1	1	*4	# nb_branch_speculated          [0][nb_context]
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/SelfTest/src/main.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/SelfTest/src/main.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/SelfTest/src/main.cpp	(revision 111)
@@ -9,5 +9,5 @@
 #include "Behavioural/Custom/include/Custom_example.h"
 
-#define NB_PARAMS 7
+#define NB_PARAMS 8
 
 void usage (int argc, char * argv[])
@@ -15,13 +15,14 @@
   err (_("<Usage> %s name_instance list_params.\n"),argv[0]);
   err (_("list_params is :\n"));
-  err (_(" * nb_context                                 (uint32_t         )\n"));
-  err (_(" * nb_inst_fetch                 [nb_context] (uint32_t         )\n"));
-  err (_(" * nb_inst_decod                              (uint32_t         )\n"));
-  err (_(" * size_queue                                 (uint32_t         )\n"));
-  err (_(" * size_general_data                          (uint32_t         )\n"));
-  err (_(" * nb_branch_speculated          [nb_context] (uint32_t         )\n"));
-  err (_(" * nb_context_select                          (uint32_t         )\n"));
-  err (_(" * select_priority                            (Tpriority_t      )\n"));
-  err (_(" * select_load_balancing                      (Tload_balancing_t)\n"));
+  err (_(" * nb_context                                 (uint32_t             )\n"));
+  err (_(" * nb_inst_fetch                 [nb_context] (uint32_t             )\n"));
+  err (_(" * nb_inst_decod                              (uint32_t             )\n"));
+  err (_(" * size_queue                                 (uint32_t             )\n"));
+  err (_(" * queue_scheme                               (Tdecod_queue_scheme_t)\n"));
+  err (_(" * size_general_data                          (uint32_t             )\n"));
+  err (_(" * nb_branch_speculated          [nb_context] (uint32_t             )\n"));
+  err (_(" * nb_context_select                          (uint32_t             )\n"));
+  err (_(" * select_priority                            (Tpriority_t          )\n"));
+  err (_(" * select_load_balancing                      (Tload_balancing_t    )\n"));
 
   exit (1);
@@ -51,4 +52,5 @@
   uint32_t            _nb_inst_decod                = fromString<uint32_t         >(argv[x++]);
   uint32_t            _size_queue                   = fromString<uint32_t         >(argv[x++]);
+  decod_queue::Tdecod_queue_scheme_t _queue_scheme  = fromString<decod_queue::Tdecod_queue_scheme_t>(argv[x++]);
   uint32_t            _size_general_data            = fromString<uint32_t         >(argv[x++]);
   uint32_t          * _nb_branch_speculated         = new uint32_t [_nb_context];
@@ -77,4 +79,5 @@
 	 _nb_inst_decod                ,
 	 _size_queue                   ,
+         _queue_scheme                 ,
 	 _size_general_data            ,
 	 _nb_branch_speculated         ,
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/include/Parameters.h	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/include/Parameters.h	(revision 111)
@@ -30,4 +30,6 @@
   public : uint32_t            _nb_inst_decod                ;
   public : uint32_t            _size_queue                   ;
+  public : decod_queue::Tdecod_queue_scheme_t
+                               _queue_scheme                 ;
 //public : uint32_t            _size_general_data            ;
   public : uint32_t          * _nb_branch_speculated         ; //[nb_context]
@@ -50,4 +52,6 @@
 			uint32_t            nb_inst_decod                ,
 			uint32_t            size_queue                   ,
+                        decod_queue::Tdecod_queue_scheme_t
+                        		    queue_scheme                 ,
 			uint32_t            size_general_data            ,
 			uint32_t          * nb_branch_speculated         ,
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/src/Parameters.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/src/Parameters.cpp	(revision 111)
@@ -23,4 +23,6 @@
 			  uint32_t            nb_inst_decod                ,
 			  uint32_t            size_queue                   ,
+                          decod_queue::Tdecod_queue_scheme_t
+                          		      queue_scheme                 ,
 			  uint32_t            size_general_data            ,
 			  uint32_t          * nb_branch_speculated         ,
@@ -40,4 +42,5 @@
     _nb_inst_decod                 = nb_inst_decod                ;
     _size_queue                    = size_queue                   ;
+    _queue_scheme                  = queue_scheme                 ;
 //  _size_general_data             = size_general_data            ;
     _nb_branch_speculated          = nb_branch_speculated         ;
@@ -71,4 +74,5 @@
        _nb_inst_decod       ,
        _size_queue          ,
+       _queue_scheme        ,
         size_general_data   ,
        _nb_branch_speculated);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/src/Parameters_print.cpp	(revision 110)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/src/Parameters_print.cpp	(revision 111)
@@ -29,4 +29,5 @@
     xml.singleton_begin("nb_inst_decod                "); xml.attribut("value",toString(_nb_inst_decod                )); xml.singleton_end();
     xml.singleton_begin("size_queue                   "); xml.attribut("value",toString(_size_queue                   )); xml.singleton_end();
+    xml.singleton_begin("queue_scheme                 "); xml.attribut("value",toString(_queue_scheme                 )); xml.singleton_end();
     xml.singleton_begin("size_general_data            "); xml.attribut("value",toString(_size_general_data            )); xml.singleton_end();
     xml.singleton_begin("nb_context_select            "); xml.attribut("value",toString(_nb_context_select            )); xml.singleton_end();
